META
{
  Parser = Game;
  Engine = G2, G2A;
  After = Gothic2SplitscreenCoop_Scripts.d;
};

// global instance of the first and second player
extern INSTANCE hero(C_NPC);
extern INSTANCE hero_2(C_NPC);

/******** 	GOTHIC 2 SPLITSCREEN COOP DAEDALUS FUNCTION INJECTIONS 			 ********/



/* GOTHIC 2 ONLY FUNCTIONS */
// Some mods remove original Gothic 2 functions, so if a mod does not feature any of these functions, 
// create a copy of this file, change the ending of it and put the functions which do not exist in the mod in comments

/************************************************************************************/
/*** 						MOBSI INJECTIONS									  ***/
/************************************************************************************/

	//Sleeping with player 2 can cause player 1 to just disappear, that's why only player 1 should be able to sleep in a bed

	//func void SLEEPABIT_S1 ()
	//{
	//	if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
	//		return;
	//	};
	//	SLEEPABIT_S1_old();
	//};

/************************************************************************************/
/*** 						EVENT TRIGGER INJECTIONS							  ***/
/************************************************************************************/

	func void EVT_TELEPORTSTATION_FUNC ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		EVT_TELEPORTSTATION_FUNC_old();
		hero = Cast_PointerToInstance(placeholder);
	};

	func void ADW_PORTALTEMPEL_FOCUS_FUNC ()
	{	
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		ADW_PORTALTEMPEL_FOCUS_FUNC_old();
		hero = Cast_PointerToInstance(placeholder);
	};

/************************************************************************************/
/*** 						ITEM INJECTIONS									 	  ***/
/************************************************************************************/

	FUNC VOID Use_CavalornsBeutel ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_CavalornsBeutel_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_StonePlate ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_StonePlate_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_StrStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_StrStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_StrStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_StrStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_StrStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_StrStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_DexStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_DexStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_DexStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_DexStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_DexStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_DexStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_HitPointStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_HitPointStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_HitPointStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_HitPointStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_HitPointStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_HitPointStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_ManaStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_ManaStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_ManaStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_ManaStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_ManaStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_ManaStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_OneHStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_OneHStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_OneHStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_OneHStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_OneHStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_OneHStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_TwoHStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_TwoHStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_TwoHStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_TwoHStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_TwoHStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_TwoHStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_BowStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_BowStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_BowStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_BowStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_BowStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_BowStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_CrsBowStonePlate1 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_CrsBowStonePlate1_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_CrsBowStonePlate2 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_CrsBowStonePlate2_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	FUNC VOID Use_CrsBowStonePlate3 ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		Use_CrsBowStonePlate3_old();
		hero = Cast_PointerToInstance(placeholder);
	};
	func int C_ScHasMagicStonePlate ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2) || Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		var int returnValue; returnValue = C_ScHasMagicStonePlate_old();
		hero = Cast_PointerToInstance(placeholder);
		return returnValue;
	};
	FUNC VOID UsePocket ()
	{
		var int placeholder; placeholder = Cast_InstanceToPointer(hero);
		if (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)){
			hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
		};
		UsePocket_old();
		hero = Cast_PointerToInstance(placeholder);
	};

/************************************************************************************/
/*** 						ZS/TA INJECTIONS							 		  ***/
/************************************************************************************/


func void B_AssessPlayer ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(other);
	if ((Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero))){
		other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	}else{
		other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
	};
	B_AssessPlayer_old();
	other = Cast_PointerToInstance(placeholder);
};

FUNC void B_AssessGuidePlayer ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	B_AssessGuidePlayer_old();
	hero = Cast_PointerToInstance(placeholder);
};

FUNC void ZS_Guide_Player ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	ZS_Guide_Player_old();
	hero = Cast_PointerToInstance(placeholder);
};

func int ZS_Guide_Player_Loop ()
{	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Guide_Player_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};

func int ZS_Follow_Player_Loop ()
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	if (Npc_GetDistToNpc(self, hero_2) < Npc_GetDistToNpc(self, hero)){
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	};
	var int returnValue; returnValue = ZS_Follow_Player_Loop_old();
	hero = Cast_PointerToInstance(placeholder);
	return returnValue;
};